package org.omg.PortableServer;

import org.omg.CORBA.portable.Delegate;
import org.omg.CORBA.BAD_PARAM;
import org.omg.CORBA.portable.ObjectImpl;
import org.omg.CORBA.Object;
import org.omg.CORBA.MARSHAL;
import org.omg.CORBA.portable.InputStream;
import org.omg.CORBA.ORB;
import org.omg.CORBA.portable.OutputStream;
import org.omg.CORBA.Any;
import org.omg.CORBA.TypeCode;

public abstract class ServantActivatorHelper
{
    private static String _id;
    private static TypeCode __typeCode;
    
    public ServantActivatorHelper() {
    }
    
    public static void insert(Any any, ServantActivator servantActivator) {
        OutputStream create_output_stream = any.create_output_stream();
        any.type(type());
        write(create_output_stream, servantActivator);
        any.read_value(create_output_stream.create_input_stream(), type());
    }
    
    public static ServantActivator extract(Any any) {
        return read(any.create_input_stream());
    }
    
    public static synchronized TypeCode type() {
        if (ServantActivatorHelper.__typeCode == null) {
            ServantActivatorHelper.__typeCode = ORB.init().create_interface_tc(id(), "ServantActivator");
        }
        return ServantActivatorHelper.__typeCode;
    }
    
    public static String id() {
        return ServantActivatorHelper._id;
    }
    
    public static ServantActivator read(InputStream inputStream) {
        throw new MARSHAL();
    }
    
    public static void write(OutputStream outputStream, ServantActivator servantActivator) {
        throw new MARSHAL();
    }
    
    public static ServantActivator narrow(org.omg.CORBA.Object object) {
        if (object == null) {
            return null;
        }
        if ((object instanceof ServantActivator)) {
            return (ServantActivator)object;
        }
        if (!object._is_a(id())) {
            throw new BAD_PARAM();
        }
        Delegate get_delegate = ((ObjectImpl)object)._get_delegate();
        _ServantActivatorStub servantActivatorStub = new _ServantActivatorStub();
        servantActivatorStub._set_delegate(get_delegate);
        return servantActivatorStub;
    }
    
    public static ServantActivator unchecked_narrow(org.omg.CORBA.Object object) {
        if (object == null) {
            return null;
        }
        if ((object instanceof ServantActivator)) {
            return (ServantActivator)object;
        }
        Delegate get_delegate = ((ObjectImpl)object)._get_delegate();
        _ServantActivatorStub servantActivatorStub = new _ServantActivatorStub();
        servantActivatorStub._set_delegate(get_delegate);
        return servantActivatorStub;
    }
    
    static {
        ServantActivatorHelper._id = "IDL:omg.org/PortableServer/ServantActivator:2.3";
        ServantActivatorHelper.__typeCode = null;
    }
}
